(****** Homework 2 for CS-565 Programming Languages - Purdue. ******)
(** !!!Due date: 09/09/2016 by 9:00PM **)
(* All 1 star and 2 stars exercises have to be completed. 3 star *)
(* exercises are optional, but completing them can compensate for failed *)
(* exercises of this and future homeworks. *)

(** * Induction: Proof by Induction *)
Require Import Lists.
Import NatList.
Require Import hw2.

Theorem mult_0_r : forall n:nat,
  n * 0 = 0.
Proof.
  apply  mult_0_r.
Qed.

Theorem plus_n_Sm : forall n m : nat,
  S (n + m) = n + (S m).
Proof.
  apply  plus_n_Sm.
Qed.

Theorem plus_comm : forall n m : nat,
  n + m = m + n.
Proof.
  apply  plus_comm.
Qed.

Theorem plus_assoc : forall n m p : nat,
  n + (m + p) = (n + m) + p.
Proof.
  apply  plus_assoc.
Qed.

Lemma double_plus :
  forall n, double n = n + n .
Proof.
  apply  double_plus.
Qed.

Theorem evenb_S : forall n : nat,
  evenb (S n) = negb (evenb n).
Proof.
  apply  evenb_S.
Qed.

Theorem plus_swap : forall n m p : nat,
  n + (m + p) = m + (n + p).
Proof.
  apply  plus_swap.
Qed.

Theorem mult_comm : forall m n : nat,
  m * n = n * m.
Proof.
  apply  mult_comm.
Qed.

Theorem leb_refl : forall n:nat,
  true = leb n n.
Proof.
  apply  leb_refl.
Qed.

Theorem zero_nbeq_S : forall n:nat,
  beq_nat 0 (S n) = false.
Proof.
  apply  zero_nbeq_S.
Qed.

Theorem andb_false_r : forall b : bool,
  andb b false = false.
Proof.
  apply  andb_false_r.
Qed.

Theorem plus_ble_compat_l : forall n m p : nat,
  leb n m = true -> leb (p + n) (p + m) = true.
Proof.
  apply  plus_ble_compat_l.
Qed.

Theorem S_nbeq_0 : forall n:nat,
  beq_nat (S n) 0 = false.
Proof.
  apply  S_nbeq_0.
Qed.

Theorem mult_1_l :
  forall n:nat, 1 * n = n.
Proof.
  apply  mult_1_l.
Qed.

Theorem all3_spec : forall b c : bool,
    orb
      (andb b c)
      (orb (negb b)
               (negb c))
  = true.
Proof.
  apply all3_spec.
Qed.

Theorem mult_plus_distr_r : forall n m p : nat,
  (n + m) * p = (n * p) + (m * p).
Proof.
  apply  mult_plus_distr_r.
Qed.

Theorem mult_assoc : forall n m p : nat,
  n * (m * p) = (n * m) * p.
Proof.
  apply  mult_assoc.
Qed.

Theorem beq_nat_refl : forall n : nat,
  true = beq_nat n n.
Proof.
  apply  beq_nat_refl.
Qed.

Theorem plus_swap' : forall n m p : nat,
  n + (m + p) = m + (n + p).
Proof.
  apply  plus_swap'.
Qed.

Theorem snd_fst_is_swap : forall (p : natprod),
  (snd p, fst p) = swap_pair p.
Proof.
  apply  snd_fst_is_swap.
Qed.

Theorem fst_swap_is_snd : forall (p : natprod),
  fst (swap_pair p) = snd p.
Proof.
  apply  fst_swap_is_snd.
Qed.

Example test_nonzeros:
  nonzeros [0;1;0;2;3;0;0] = [1;2;3].
Proof.
  apply test_nonzeros.
Qed.

Example test_oddmembers:
  oddmembers [0;1;0;2;3;0;0] = [1;3].
Proof.
  apply  test_oddmembers.
Qed.

Example test_countoddmembers1:
  countoddmembers [1;0;3;1;4;5] = 4.
Proof.
  apply  test_countoddmembers1.
Qed.

Example test_countoddmembers2:
  countoddmembers [0;2;4] = 0.
Proof.
  apply  test_countoddmembers2.
Qed.

Example test_countoddmembers3:
  countoddmembers nil = 0.
Proof.
  apply  test_countoddmembers3.
Qed.

Theorem bag_theorem :
forall b b' : bag,
  forall v,
    count v (sum b b') = count v (sum b' b).
Proof.
  intros; eapply hw2.bag_theorem.
Qed.

Theorem app_nil_r : forall l : natlist,
  l ++ [] = l.
Proof.
  apply  app_nil_r.
Qed.

Theorem rev_involutive : forall l : natlist,
  rev (rev l) = l.
Proof.
  apply  rev_involutive.
Qed.

Theorem app_assoc4 : forall l1 l2 l3 l4 : natlist,
  l1 ++ (l2 ++ (l3 ++ l4)) = ((l1 ++ l2) ++ l3) ++ l4.
Proof.
  apply  app_assoc4.
Qed.

Example test_beq_natlist1 :
  (beq_natlist nil nil = true).
Proof.
  apply  test_beq_natlist1.
Qed.

Example test_beq_natlist2 :
  beq_natlist [1;2;3] [1;2;3] = true.
Proof.
  apply  test_beq_natlist2.
Qed.

Example test_beq_natlist3 :
  beq_natlist [1;2;3] [1;2;4] = false.
Proof.
  apply  test_beq_natlist3.
Qed.

Theorem beq_natlist_refl : forall l:natlist,
  true = beq_natlist l l.
Proof.
  apply  beq_natlist_refl.
Qed.

Example test_hd_error1 :
  hd_error [] = None.
Proof.
  apply  test_hd_error1.
Qed.

Example test_hd_error2 :
  hd_error [1] = Some 1.
Proof.
  apply  test_hd_error2.
Qed.

Example test_hd_error3 :
  hd_error [5;6] = Some 5.
Proof.
  apply  test_hd_error3.
Qed.

Theorem option_elim_hd : forall (l:natlist) (default:nat),
  hd default l = option_elim default (hd_error l).
Proof.
  apply  option_elim_hd.
Qed.

Print Assumptions mult_0_r.

Print Assumptions plus_n_Sm.

Print Assumptions plus_comm.

Print Assumptions plus_assoc.

Print Assumptions double_plus.

Print Assumptions evenb_S.

Print Assumptions plus_swap.

Print Assumptions mult_comm.

Print Assumptions leb_refl.

Print Assumptions zero_nbeq_S.

Print Assumptions andb_false_r.

Print Assumptions plus_ble_compat_l.

Print Assumptions S_nbeq_0.

Print Assumptions mult_1_l.

Print Assumptions all3_spec.

Print Assumptions mult_plus_distr_r.

Print Assumptions mult_assoc.

Print Assumptions beq_nat_refl.

Print Assumptions plus_swap'.

Print Assumptions snd_fst_is_swap.

Print Assumptions fst_swap_is_snd.

Print Assumptions test_nonzeros.

Print Assumptions test_oddmembers.

Print Assumptions test_countoddmembers1.

Print Assumptions test_countoddmembers2.

Print Assumptions test_countoddmembers3.

Print Assumptions bag_theorem.

Print Assumptions app_nil_r.

Print Assumptions rev_involutive.

Print Assumptions app_assoc4.

Print Assumptions test_beq_natlist1.

Print Assumptions test_beq_natlist2.

Print Assumptions test_beq_natlist3.

Print Assumptions beq_natlist_refl.

Print Assumptions test_hd_error1.

Print Assumptions test_hd_error2.

Print Assumptions test_hd_error3.

Print Assumptions option_elim_hd.
